#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "modelc.h"
double getphi(int iyr, int iage, int igrp) {
/*
               LOAD PHI MATRIX FROM PARAM VECTOR
*/
    double ss(int i); int j,k,l,jphi;  // jphi points to movement computed by subtraction.
	double sm=0,survl=0,sumerr=0;
    j=(iage-1)*(nyrs-1)+iyr;
	if (iphi[0]>=0) {          //  s-psi parameterization 
		for (k=1; k<=nstrat; k++) {  //  SUM=SUM OF MOVEMENT PROBS
			survl=ss(jsrv[k][j][igrp]); 
			jphi=iphi[k];
			for (sm=0, l=1; l<=nstrat; l++)
				if (l!=jphi) {
					sm+=ss(jmv[k][l][j][igrp]);
					phi[k][l]=pow(survl,t[iyr])*ss(jmv[k][l][j][igrp]);
				} 
			phi[k][jphi]=pow(survl,t[iyr])*(1.-sm);
			if (sm>1) sumerr=2;
		}
	}
	else {         //  phi-parameterization
		for (k=1; k<=nstrat; k++) {  //  SUM=SUM OF MOVEMENT PROBS
			phi[k][k]=ss(jsrv[k][j][igrp]);
			for (sm=phi[k][k], l=1; l<=nstrat; l++)
				if (k!=l) {
					phi[k][l]=ss(jmv[k][l][j][igrp]);
					sm+=phi[k][l];
				}
			if (sm>1) sumerr=2;
		}
	}
	return(sumerr);
}

