#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#define MXMOD 50
int main(int argc, char **argv) {
    double cdtr(double x2, int idf, int *ier);
    int ii=0,mgm=1,ier,i,j,iptr=0,isrt=4,k,modnum=0,lo,itmp,inum,idem,pnum=0;
    long sumn=0; FILE *f;
    double c=0,chisq,prob,tmp,val,se,c1,c2; char ctmp[800],*pj,fname[256];
    double g[MXMOD],xll[MXMOD],px2[MXMOD],sqrtc=1;
    int df[MXMOD],nest[MXMOD],df1,isv[MXMOD],pdf[MXMOD];
    double aic[MXMOD][5]; char modnam[MXMOD][80],parmnum[12];
    for (i=0; i<MXMOD; i++) nest[i]=0;
    //          MGM=MODEL NUMBER OF MOST-GENERAL-MODEL
    for (i=1; i<argc; i++) {
        strcpy(fname,argv[i]); 
        if (strncmp(fname,"c=",2)==0) { c=atof(fname+2); sqrtc=sqrt(c); printf("c=%f\n",c);}
        else {
            printf("opening %s ",fname);
            if ((f=fopen(fname,"r"))==NULL) { 
                printf("error opening %s\n",fname); 
            }
            else {
                strcpy(modnam[++modnum],fname);
                for (;(fgets(ctmp,800,f)!=NULL);) {
                    pj=strstr(ctmp,"Cohort N="); 
                    if (pj!=NULL && modnum==1) { 
                        sumn+=atoi(pj+9);  //    sum cohorts for corrected AIC
                    }
//@@    1  130    0 351       2490.75 263       18158.4     -1666.66      3445.32
                    pj=strstr(ctmp,"@@"); 
                    if (pj!=NULL) { 
                        df[modnum]=atoi(ctmp+17);
                        g[modnum]=atof(ctmp+21);
                        px2[modnum]=atof(ctmp+40);
                        pdf[modnum]=atoi(ctmp+36); 
                        xll[modnum]=atof(ctmp+54);
                    }
                    pj=strstr(ctmp,"name="); 
                    if (pj!=NULL) { 
                        for (j=5; pj[j]!=' ' && pj[j]!=';'; j++);
                        strncpy(modnam[modnum],pj+5,j-5);
                        modnam[modnum][j-5]=NULL; 
                        printf("name=%s\n",modnam[modnum]);
                    }
                    pj=strstr(ctmp,"umber of parameters in model  ="); 
                    if (pj!=NULL && nest[modnum]==0) { 
                        nest[modnum]=atoi(pj+31);
                    }
                    pj=strstr(ctmp,"cols="); 
                    if (pj!=NULL) { 
                        nest[modnum]=atoi(pj+5); 
                    }
                    pj=strstr(ctmp,"tandard Error"); 
                    if (pj!=NULL) { 
                        strcpy(parmnum,"   1 "); pnum=1;
                    }
                    if (strncmp(ctmp,parmnum,5)==0) {
                        val=atof(ctmp+28);
                        se=sqrtc*atof(ctmp+41);
                        c1=val-se*1.96; c2=val+se*1.96;
                        sprintf(ctmp+41,"%12.6lg** %10.6lg %12.6lg\n",se,c1,c2);
                        sprintf(parmnum,"%4d ",++pnum);
                    }
                    if (modnum==1) printf("%s",ctmp);
                }
//            printf("df,nest,g,xll,sumn=%d %d %lf %lf %ld\n",df[modnum],nest[modnum],g[modnum],xll[modnum],sumn);
                fclose(f);
            }
        }
    }
    printf("modnum=%d\n",modnum);
    for (i=1,mgm=1; i<=modnum; i++) {
        isv[i]=i;
        aic[i][1]=-2.0*xll[i]+2.0*nest[i];
        aic[i][2]=aic[i][1]+2.0*nest[i]*(nest[i]+1)/ (double)(sumn-nest[i]-1);
        if (nest[i]>nest[mgm]) mgm=i;
    }
    if (c<1.0 && df[mgm]!=0) c=g[mgm]/(double)(df[mgm]);
    if (c<1.0)c=1;
    //                COMPUTE QUASI-AIC (AIC(*,3)) & CORRECTED QAIC (AIC(*,4))
    printf("\nModified AIC calculations: (see 'Model Selection and Inference:\n");
    printf( " A Practical Information Theoretic Approach by K. P. Burnham\n");
    printf( " and David R. Anderson, 1998\n");
    printf("\n  Most General Model:%s\n",modnam[mgm]);
    printf(  "  n=%d c=%f\n",sumn,c);
    printf(  "  Model                       NPAR   G-Total      df   Pooled-X2     df    Prob\n");
    for (i=1; i<=modnum; i++) {
        aic[i][3]=-2.0*xll[i]/c+2.0*nest[i];
        aic[i][4]=aic[i][3]+2.0*nest[i]*(nest[i]+1)/(double)(sumn-nest[i]-1);
        prob=1.-cdtr(px2[i],pdf[i],&ier);
        printf("%4d %-20s %7d %10.2f %7d %10.2f %7d %8.4f\n",
               i,modnam[i],nest[i],g[i],df[i],px2[i],pdf[i],prob);
    }
    //                SORT MODELS BY AIC
    for (i=1; i<modnum; i++) {
        for (lo=i, j=i+1; j<=modnum; j++)  { 
            if (aic[j][isrt]<aic[lo][isrt]) lo=j;
        }
        itmp=isv[i]; isv[i]=isv[lo]; isv[lo]=itmp;
        strcpy(ctmp,modnam[i]); strcpy(modnam[i],modnam[lo]); strcpy(modnam[lo],ctmp);
        //  strcpy(ctmp,modnam[i]); strcpy(modnam[i],modnam[lo]); strcpy(modnam[lo],ctmp);
        tmp=xll[i]; xll[i]=xll[lo]; xll[lo]=tmp;
        for (j=1; j<=4; j++) {
            tmp=aic[i][j]; aic[i][j]=aic[lo][j]; aic[lo][j]=tmp;
        }
 //       itmp=dfsav[i]; dfsav[i]=dfsav[lo]; dfsav[lo]=itmp;
        itmp=nest[i]; nest[i]=nest[lo]; nest[lo]=itmp;
//        tmp=modgof[i]; modgof[i]=modgof[lo]; modgof[lo]=tmp;
        tmp=g[i]; g[i]=g[lo]; g[lo]=tmp;
        itmp=df[i]; df[i]=df[lo]; df[lo]=itmp;
    }
    printf("\n                         Log-\n");
    printf("  Model               likelihood      AIC       AICC     QAIC      QAICC\n");
    printf(" ---------            ----------   ---------  --------  --------  -------\n");
    for (i=1; i<=modnum; i++) {
        printf("%d %-20s %10.4f %9.2f %9.2f %9.2f %9.2f\n",
                isv[i],modnam[i],xll[i],aic[i][1],aic[i][2],aic[i][3],aic[i][4]);
    }	
    printf("\nLikelihood Ratio Tests Between Models\n");
    printf(" General              Reduced                           Degrees   Pr(Larger\n");
    printf(" Submodel             Submodel              Chi-square  Freedom  Chi-square)\n");
    printf("----------           ----------             ----------  -------  -----------\n");
    for (i=1; i<modnum; i++)
        for (j=i+1; j<=modnum; j++) {
            if (df[i]>df[j]) { inum=i; idem=j; }
            if (df[i]<df[j]) { inum=j; idem=i;}
            if (df[i]!=df[j]) {
                chisq=-2.0*(xll[inum]-xll[idem]);
                df1=df[inum]-df[idem];
                if (chisq>0. && df>0) {
                    prob=cdtr(chisq,df1,&ier);
                    if (ier!=0) printf("\nerror with chi-square probability.\n");
                    prob=1.0-prob;
                }
                else { prob=1.0; chisq=0.0; }
                printf(" %10s%22s %21.3f%7d%13.4f\n",modnam[idem],modnam[inum],chisq,df1,prob);
            }
        }
}

#define dabs(x) (x<0 ? -x : x)
double cdtr(double chisq, int idf, int *ier) {
/* C  *DECK CDTR
C
C     ..................................................................
C
C        SUBROUTINE CDTR
C
C        PURPOSE
C           COMPUTES P(CHISQ) = PROBABILITY THAT THE RANDOM VARIABLE U,
C           DISTRIBUTED ACCORDING TO THE CHI-SQUARE DISTRIBUTION WITH G
C           DEGREES OF FREEDOM, IS LESS THAN OR EQUAL TO CHISQ.  F(G,CHI
C           ORDINATE OF THE CHI-SQUARE DENSITY AT CHISQ, IS ALSO COMPUTE
C
C        USAGE
C           CALL CDTR(CHISQ,IDF,SIGCHI,IER)
C
C        DESCRIPTION OF PARAMETERS
C           CHISQ   - INPUT SCALAR FOR WHICH P(CHISQ) IS COMPUTED.
C           IDF     - NUMBER OF DEGREES OF FREEDOM OF THE CHI-SQUARE
C                     DISTRIBUTION.  IDF IS AN INTEGER.
C           SIGCHI  - OUTPUT PROBABILITY.
C           IER     - RESULTANT ERROR CODE WHERE
C               IER= 0 --- NO ERROR
C               IER=-1 --- AN INPUT PARAMETER IS INVALID.  X IS LESS
C                          THAN 0.0, OR IDF IS LESS THAN 0.0 OR GREATER
C                          THAN 2*10**(+5).  P AND D ARE SET TO -1.E25.
C               IER=-2 --- IDF = 0, P SET TO 0.
C               IER=+1 --- INVALID OUTPUT.  P IS LESS THAN ZERO OR
C                          GREATER THAN ONE, OR SERIES FOR T1 (SEE
C                          MATHEMATICAL DESCRIPTION) HAS FAILED TO
C                          CONVERGE.  P IS SET TO 1.E25.
C
C        SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED
C           NDTR
C
C        METHOD
C
C     THIS FUNCTION WAS LIFTED FROM "NWAY" WRITTEN BY THE STANFORD
C     COMPUTATION CENTER. THE SCC BORROWED IT FROM JOHN MORRIS OF THE
C     COMPUTER INSTITUTE FOR SOCIAL SCIENCE RESEARCH AT MICHIGAN STATE
C     UNIVERSITY.
   C */
    int i,crap;
    double sigchi=0,anschi=1,ff,p,xi,pp,term,argnrm,gam=1,txx;
	double ndtr(double x);
    //   FACTORIALS OF 0,0 THROUGH 30. .
    double fact[]={1.,1.,2.,6.,24.,120.,720.,5040.,40320.,
        362880.,3628800.,3.99168e7,4.790016e8,6.2270208e9,
        8.71782912e10,1.307674368e12,2.0922789888e13,3.55687428096e14,
        6.402373705728e15,1.21645100408832e17,2.43290200817664e18,
        5.10909421717094e19,1.12400072777761e21,2.58520167388850e22,
        6.20448401733239e23,1.55112100433310e25,4.03291461126606e26,
        1.08888694504184e28,3.04888344611714e29,8.84176199373970e30,
        2.65252859812191e32};
	*ier=0;
    if (chisq<0 || idf<0) { *ier=-1;  sigchi=-1.e25;  }
    if (idf>0 && (chisq+100.)!=100.) {
        //      GT 60 D.F. OR CHI GT 100 - USE A NORMAL APPROXIMATION
        if (idf>60. || chisq>100.) {
            argnrm=sqrt(2.*chisq)-sqrt(2.*(double) idf -1.);
            sigchi=ndtr(argnrm);
        }
        else {
            ff=idf-2; p=0.5*ff; xi=0.5*chisq; pp=p+2; term=xi/pp;
            for (i=1; i<=100; i++) {
				anschi+=term;
				if (dabs(term)<.000001) break;
				term*=(xi/++pp);
			}
            gam=1; crap=idf&1;
            if ((idf&1)==0)  // if even
				gam=fact[idf/2];
            else {
                for (i=1; i<=idf; i+=2) gam*=((double) i)*0.5;
                gam*=1.7724588509;
            }
            txx=(p+1.)*log(xi)- xi + log(anschi/gam);
            if (txx<=88.)
                if (txx>-88.) anschi=exp(txx);
                else anschi=0.;
            else anschi=1.;
            sigchi=anschi;
        }
        if (sigchi<0 || sigchi>1.) { *ier=1; sigchi=1.e25; }
    }
    return(sigchi);
}
double ndtr(double x) {
/* C  *DECK NDTR
C        SUBROUTINE NDTR
C
C        PURPOSE
C           COMPUTES Y = P(X) = PROBABILITY THAT THE RANDOM VARIABLE  U,
C           DISTRIBUTED NORMALLY(0,1), IS LESS THAN OR EQUAL TO X.
C           F(X), THE ORDINATE OF THE NORMAL DENSITY AT X, IS ALSO
C           COMPUTED.
C
C        USAGE
C           CALL NDTR(X,P)
C
C        DESCRIPTION OF PARAMETERS
C           X--INPUT SCALAR FOR WHICH P(X) IS COMPUTED.
C           P--OUTPUT PROBABILITY.
C
C        REMARKS
C           MAXIMUM ERROR IS 0.0000007.
C
C        SUBROUTINES AND SUBPROGRAMS REQUIRED
C           NONE
C
C        METHOD
C           BASED ON APPROXIMATIONS IN C. HASTINGS, APPROXIMATIONS FOR
C           DIGITAL COMPUTERS, PRINCETON UNIV. PRESS, PRINCETON, N.J.,
C           1955.  SEE EQUATION 26.2.17, HANDBOOK OF MATHEMATICAL
C           FUNCTIONS, ABRAMOWITZ AND STEGUN, DOVER PUBLICATIONS, INC.,
C           NEW YORK.
C
   SUBROUTINE NDTR (X,P) */
    double p,t,d;
    t=1./(1.+.2316419*dabs(x));
    if (-x*x*0.5<-700) d=0.3989423*exp(-700.);
    else d=0.3989423*exp(-x*x*0.5);
    p=1.0-d*t*((((1.330274*t-1.821256)*t+1.781478)*t-0.3565638)*t+0.3193815);
    if (x<0.) p=1.-p;
    return(p);
}
