#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "status.h"
#include "modelc.h"
void inital(FILE *F, double *ppar) {

    int getcmd(FILE *x); void srverror(char *x); void srvwarn(char *x);	double ss(int i);
    int i; double psi,xp,xcpstar,xcp,srv,tmpval;
    
    i=getcmd(F); indent=3; printf(">>>sub initial\n"); fprintf(G,"INPUT--%s\n",lststr); 
    if (stricmp(words[1],"SMART")==0) {
        srv=atof(words[2]); 
        if (lstwrd>=3) psi=atof(words[3]);
        if (lstwrd>=4) xp=atof(words[4]); 
        if (lstwrd>=5) xcp=atof(words[5]);
        if (lstwrd>=6) xcpstar=atof(words[6]);
        for (i=1; i<=nrows; i++) {
            if (strnicmp(slabel[i],"SRV",3)==0 || strnicmp(slabel[i],"PHI",3)==0) 
                ppar[i]=srv;
            if (strnicmp(slabel[i],"PSI",3)==0 || strnicmp(slabel[i],"MOV",3)==0) ppar[i]=psi;
            if (strnicmp(slabel[i],"P(",2)==0) ppar[i]=xp;
            if (strnicmp(slabel[i],"CP",2)==0) ppar[i]=xcp;
            if (strnicmp(slabel[i],"CP*",3)==0) ppar[i]=xcpstar;
        }
    }
    else if (stricmp(words[1],"ALL")==0) 
        for (i=1; i<=nrows; i++) ppar[i]=atof(words[3]);
    else if (stricmp(words[1],"RETAIN")==0) {
        if (modnum<=1) srvwarn("NO PREV MODEL FOR RETAIN");
        else {
            for (i=1; i<=npar; i++) {       //ppar[i]=parini[i][modnum-1];
                fprintf(G,"%d %f\n",i,ppar[i]);
            }
        }
    }
    else if (stricmp(words[1],"SURVIV")==0) {
        for (i=0; stricmp(words[1],"END")!=0; ) {
            getcmd(F); i++;
            if (stricmp(words[1],"END")!=0) 
                ppar[i]=atof(words[3]);
        }
    }
    else if (strnicmp(words[1],"B(",2)==0) {
        i=atoi(words[1]+2); tmpval=atof(words[3]);
        ppar[i]=exp(tmpval)/(1.+exp(tmpval));
    }
    else if (strnicmp(words[1],"Betas",5)==0) {
        for (i=2; i<=lstwrd; i++) { 
		    tmpval=atof(words[i]); ppar[i-1]=exp(tmpval)/(1.+exp(tmpval)); 
		}
    }
    else {
	    printf(">>>words:%s,%s,%s.lstwrd=%d\n",words[1],words[2],words[3],lstwrd);
        for (i=1; i<=lstwrd; i++) {
            printf(">>>words(%d)=%s\n",i,words[i]);
			srv=atof(words[i]); // fprintf(G,"%4d %s.\n",i,slabel[i]);
            ppar[i]=(srv<0.995?srv:0.99);
        }
    }
}
