#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include "modelc.h"
#include "status.h"
double ss(int i, int icoht, int icls) {
    /* DOUBLE PRECISION FUNCTION SS(I) :  v=individ. covariate associated w/ last parameter*/
    double xs,sm,v; int j; char stmp[80];
    double dabs (double x); void srverror(char *x); void srvwarn(char *x);
    if (i>nreal) {
        j=sprintf(stmp,"S(I) IN CELL PROBABILITY WITH I>NPAR (%d>%d)",i,nreal);
        srverror(stmp);
    }
    if (i<=0) 
        xs=fix[-i+1]; //   ZER0 INDICATES A FIXED PARAMETER = 0
    else {
        if (itrans==0) xs=par[i];
        else 
            if (idmat==1) sm=par[i];
            else {
				for (sm=0, j=1; j<=ncols; j++)  {
					v=desmat[i][j];
					if (v < -100.) v=icov[icoht][icls][(int)floor(-v-101)];
					sm+=par[j]*v;
				}
			}
        if (itrans==1) xs=sin(sm)/2.+0.5;
        else if (itrans==2) {
            if (sm<-40.) sm=-40;
            if (sm>40.) sm=40.;
            xs=exp(sm)/(1.+exp(sm));
        }
        else if (itrans==3) xs=dabs(sm)-floor(dabs(sm));
    }
    return(xs);
}
